---
apiVersion: v1
kind: ServiceAccount
metadata:
  namespace: default
  name: agent-operator-sa
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
  name: agent-operator-role
rules:
  # Pools
  - apiGroups: ["agent.opentestfactory.org"]
    resources: ["pools"]
    verbs: ["get", "list", "watch", "update", "patch"]

  # Secrets
  - apiGroups: [""]
    resources: ["secrets"]
    verbs: ["get", "list", "watch"]

  # Pods

  - apiGroups: [""]
    resources: ["pods", "pods/status", "pods/exec"]
    verbs: ["get", "list", "watch", "create", "update", "patch", "delete"]

  # Framework: runtime observation of namespaces & CRDs (addition/deletion).
  - apiGroups: [apiextensions.k8s.io]
    resources: [customresourcedefinitions]
    verbs: [list, watch]
  - apiGroups: [""]
    resources: [namespaces]
    verbs: [list, watch]

  # Framework: admission webhook configuration management.
  - apiGroups: [admissionregistration.k8s.io/v1, admissionregistration.k8s.io/v1beta1]
    resources: [validatingwebhookconfigurations, mutatingwebhookconfigurations]
    verbs: [create, patch]

---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  namespace: default
  name: agent-operator-role-namespaced
rules:

  # Pools

  - apiGroups: ["agent.opentestfactory.org"]
    resources: ["pools"]
    verbs: ["get", "list", "watch", "create", "update", "patch", "delete"]

  # Secrets
  - apiGroups: [""]
    resources: ["secrets"]
    verbs: ["get", "list", "watch"]

    # Pods

  - apiGroups: [""]
    resources: ["pods", "pods/status", "pods/exec"]
    verbs: ["get", "list", "watch", "create", "update", "patch", "delete"]

  # Framework: posting the events about the handlers progress/errors.
  - apiGroups: [""]
    resources: [events]
    verbs: [create]

---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: agent-operator-binding
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: agent-operator-role
subjects:
  - kind: ServiceAccount
    name: agent-operator-sa
    namespace: default
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  namespace: default
  name: agent-operator-rolebinding-namespaced
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: agent-operator-role-namespaced
subjects:
  - kind: ServiceAccount
    name: agent-operator-sa
